
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>varnishncsa &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="varnishstat" href="varnishstat.html" />
    <link rel="prev" title="varnishlog" href="varnishlog.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="varnishstat.html" title="varnishstat"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="varnishlog.html" title="varnishlog"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">The Varnish Reference Manual</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">varnishncsa</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="varnishncsa">
<span id="varnishncsa-1"></span><h1>varnishncsa<a class="headerlink" href="#varnishncsa" title="Permalink to this headline">¶</a></h1>
<section id="display-varnish-logs-in-apache-ncsa-combined-log-format">
<h2>Display Varnish logs in Apache / NCSA combined log format<a class="headerlink" href="#display-varnish-logs-in-apache-ncsa-combined-log-format" title="Permalink to this headline">¶</a></h2>
<dl class="field-list simple">
<dt class="field-odd">Manual section</dt>
<dd class="field-odd"><p>1</p>
</dd>
</dl>
<section id="synopsis">
<h3>SYNOPSIS<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h3>
<p>varnishncsa [-a] [-b] [-c] [-C] [-d] [-D] [-F &lt;format&gt;] [-f &lt;formatfile&gt;] [-g &lt;request|vxid&gt;] [-h] [-L &lt;limit&gt;] [-n &lt;dir&gt;] [-P &lt;file&gt;] [-q &lt;query&gt;] [-r &lt;filename&gt;] [-R &lt;limit[/duration]&gt;] [-t &lt;seconds|off&gt;] [-V] [-w &lt;filename&gt;]</p>
</section>
<section id="description">
<h3>DESCRIPTION<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h3>
<p>The varnishncsa utility reads varnishd(1) shared memory logs and
presents them in the Apache / NCSA “combined” log format.</p>
<p>Each log line produced is based on a single Request type transaction
gathered from the shared memory log. The Request transaction is then
scanned for the relevant parts in order to output one log line. To
filter the log lines produced, use the query language to select the
applicable transactions. Non-request transactions are ignored.</p>
<p>The following options are available:</p>
<dl class="option-list">
<dt><kbd><span class="option">-a</span></kbd></dt>
<dd><p>When writing output to a file, append to it rather than overwrite it.</p>
</dd>
<dt><kbd><span class="option">-b</span></kbd></dt>
<dd><p>Log backend requests. If -c is not specified, then only backend requests will trigger log lines.</p>
</dd>
<dt><kbd><span class="option">-c</span></kbd></dt>
<dd><p>Log client requests. This is the default. If -b is specified, then -c is needed to also log client requests</p>
</dd>
<dt><kbd><span class="option">-C</span></kbd></dt>
<dd><p>Do all regular expression and string matching caseless.</p>
</dd>
<dt><kbd><span class="option">-d</span></kbd></dt>
<dd><p>Process log records at the head of the log and exit.</p>
</dd>
<dt><kbd><span class="option">-D</span></kbd></dt>
<dd><p>Daemonize.</p>
</dd>
<dt><kbd><span class="option">-F <var>&lt;format&gt;</var></span></kbd></dt>
<dd><p>Set the output log format string.</p>
</dd>
<dt><kbd><span class="option">-f <var>&lt;formatfile&gt;</var></span></kbd></dt>
<dd><p>Read output format from a file. Will read a single line from the specified file, and use that line as the format.</p>
</dd>
<dt><kbd><span class="option">-g <var>&lt;request|vxid&gt;</var></span></kbd></dt>
<dd><p>The grouping of the log records. The default is to group by vxid.</p>
</dd>
<dt><kbd><span class="option">-h</span></kbd></dt>
<dd><p>Print program usage and exit</p>
</dd>
<dt><kbd><span class="option">-L <var>&lt;limit&gt;</var></span></kbd></dt>
<dd><p>Sets the upper limit of incomplete transactions kept before the oldest transaction is force completed. A warning record is synthesized when this happens. This setting keeps an upper bound on the memory usage of running queries. Defaults to 1000 transactions.</p>
</dd>
<dt><kbd><span class="option">-n <var>&lt;dir&gt;</var></span></kbd></dt>
<dd><p>Specify the varnishd working directory (also known as instance name) to get logs from. If -n is not specified, the host name is used.</p>
</dd>
<dt><kbd><span class="option">-P <var>&lt;file&gt;</var></span></kbd></dt>
<dd><p>Write the process’ PID to the specified file.</p>
</dd>
<dt><kbd><span class="option">-q <var>&lt;query&gt;</var></span></kbd></dt>
<dd><p>Specifies the VSL query to use.</p>
</dd>
<dt><kbd><span class="option">-r <var>&lt;filename&gt;</var></span></kbd></dt>
<dd><p>Read log in binary file format from this file. The file can be created with <code class="docutils literal notranslate"><span class="pre">varnishlog</span> <span class="pre">-w</span> <span class="pre">filename</span></code>.</p>
</dd>
<dt><kbd><span class="option">-R <var>&lt;limit[/duration]&gt;</var></span></kbd></dt>
<dd><p>Restrict the output to the specified limit. Transactions exceeding the limit will be suppressed. The limit is specified as the maximum number of transactions (with respect to the chosen grouping method) and an optional time period. If no duration is specified, a default of <code class="docutils literal notranslate"><span class="pre">s</span></code> is used. The duration field can be formatted as in VCL (e.g. <code class="docutils literal notranslate"><span class="pre">-R</span> <span class="pre">10/2m</span></code>) or as a simple time period without the prefix (e.g. <code class="docutils literal notranslate"><span class="pre">-R</span> <span class="pre">5/m</span></code>). When in <code class="docutils literal notranslate"><span class="pre">-g</span> <span class="pre">raw</span></code> grouping mode, this setting can not be used alongside <code class="docutils literal notranslate"><span class="pre">-i</span></code>, <code class="docutils literal notranslate"><span class="pre">-I</span></code>, <code class="docutils literal notranslate"><span class="pre">-x</span></code> or <code class="docutils literal notranslate"><span class="pre">-X</span></code>, and we advise using <code class="docutils literal notranslate"><span class="pre">-q</span></code> instead.</p>
</dd>
<dt><kbd><span class="option">-t <var>&lt;seconds|off&gt;</var></span></kbd></dt>
<dd><p>Timeout before returning error on initial VSM connection. If set the VSM connection is retried every 0.5 seconds for this many seconds. If zero the connection is attempted only once and will fail immediately if unsuccessful. If set to “off”, the connection will not fail, allowing the utility to start and wait indefinetely for the Varnish instance to appear.  Defaults to 5 seconds.</p>
</dd>
<dt><kbd><span class="option">-V</span></kbd></dt>
<dd><p>Print version information and exit.</p>
</dd>
<dt><kbd><span class="option">-w <var>&lt;filename&gt;</var></span></kbd></dt>
<dd><p>Redirect output to file. The file will be overwritten unless the -a option was specified. If the application receives a SIGHUP in daemon mode the file will be reopened allowing the old one to be rotated away. This option is required when running in daemon mode.</p>
</dd>
<dt><kbd><span class="option">--optstring</span></kbd></dt>
<dd><p>Print the optstring parameter to <code class="docutils literal notranslate"><span class="pre">getopt(3)</span></code> to help writing wrapper scripts.</p>
</dd>
</dl>
</section>
<section id="modes">
<h3>MODES<a class="headerlink" href="#modes" title="Permalink to this headline">¶</a></h3>
<p>The default mode of varnishncsa is “client mode”.  In this mode, the
log will be similar to what a web server would produce in the absence
of varnish.  Client mode can be explicitly selected by using -c.</p>
<p>If the -b switch is specified, varnishncsa will operate in “backend
mode”.  In this mode, requests generated by varnish to the backends
will be logged.  Unless -c is also specified, client requests received
by varnish will be ignored.</p>
<p>When running varnishncsa in both backend and client mode, it is
strongly advised to include the format specifier %{Varnish:side}x to
distinguish between backend and client requests.</p>
<p>Client requests that results in a pipe (ie. return(pipe) in vcl), will
not generate logging in backend mode. This is because varnish is not
generating requests, but blindly passes on bytes in both directions.
However, a varnishncsa instance running in normal mode can see this
case by using the formatter %{Varnish:handling}x, which will be ‘pipe’.</p>
<p>In backend mode, some of the fields in the format string get different
meanings.  Most notably, the byte counting formatters (%b, %I, %O)
considers varnish to be the client.</p>
<p>It is possible to keep two varnishncsa instances running, one in
backend mode, and one in client mode, logging to different files.</p>
</section>
<section id="format">
<h3>FORMAT<a class="headerlink" href="#format" title="Permalink to this headline">¶</a></h3>
<p>Specify the log format to use. If no format is specified the default log
format is used:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">%</span><span class="n">h</span> <span class="o">%</span><span class="n">l</span> <span class="o">%</span><span class="n">u</span> <span class="o">%</span><span class="n">t</span> <span class="s2">&quot;</span><span class="si">%r</span><span class="s2">&quot;</span> <span class="o">%</span><span class="n">s</span> <span class="o">%</span><span class="n">b</span> <span class="s2">&quot;%</span><span class="si">{Referer}</span><span class="s2">i&quot;</span> <span class="s2">&quot;%{User-agent}i&quot;</span>
</pre></div>
</div>
<p>Escape sequences \n and \t are supported.</p>
<p>Supported formatters are:</p>
<dl>
<dt>%b</dt><dd><p>In client mode, size of response in bytes, excluding HTTP headers.
In backend mode, the number of bytes received from the backend,
excluding HTTP headers.  In CLF format, i.e. a ‘-’ rather than a 0
when no bytes are sent.</p>
</dd>
<dt>%D</dt><dd><p>In client mode, time taken to serve the request, in microseconds.
In backend mode, time from the request was sent to the entire body
had been received. This is equivalent to %{us}T.</p>
</dd>
<dt>%H</dt><dd><p>The request protocol. Defaults to HTTP/1.0 if not known.</p>
</dd>
<dt>%h</dt><dd><p>Remote host. Defaults to ‘-’ if not known.  In backend mode this is
the IP of the backend server.</p>
</dd>
<dt>%I</dt><dd><p>In client mode, total bytes received from client.  In backend mode,
total bytes sent to the backend.</p>
</dd>
<dt>%{X}i</dt><dd><p>The contents of request header X. If the header appears multiple times
in a single transaction, the last occurrence is used.</p>
</dd>
<dt>%l</dt><dd><p>Remote logname. Always ‘-‘.</p>
</dd>
<dt>%m</dt><dd><p>Request method. Defaults to ‘-’ if not known.</p>
</dd>
<dt>%{X}o</dt><dd><p>The contents of response header X. If the header appears multiple
times in a single transaction, the last occurrence is used.</p>
</dd>
<dt>%O</dt><dd><p>In client mode, total bytes sent to client.  In backend mode, total
bytes received from the backend.</p>
</dd>
<dt>%q</dt><dd><p>The query string. Defaults to an empty string if not present.</p>
</dd>
<dt>%r</dt><dd><p>The first line of the request. Synthesized from other fields, so it
may not be the request verbatim. See the NOTES section.</p>
</dd>
<dt>%s</dt><dd><p>Status sent to the client.  In backend mode, status received from
the backend.</p>
</dd>
<dt>%t</dt><dd><p>In client mode, time when the request was received, in HTTP
date/time format.  In backend mode, time when the request was sent.</p>
</dd>
<dt>%{X}t</dt><dd><p>In client mode, time when the request was received, in the format
specified by X.  In backend mode, time when the request was sent.
The time specification format is the same as for strftime(3).</p>
</dd>
<dt>%T</dt><dd><p>In client mode, time taken to serve the request, in seconds.  In
backend mode, time from the request was sent to the entire body had
been received. This is equivalent to %{s}T.</p>
</dd>
<dt>%{X}T</dt><dd><p>In client mode, time taken to serve the request, in the format
specified by X.  In backend mode, time from the request was sent to
the entire body had been received. The time specification format can
be one of the following: s (same as %T), ms or us (same as %D).</p>
</dd>
<dt>%U</dt><dd><p>The request URL without the query string. Defaults to ‘-’ if not
known.</p>
</dd>
<dt>%u</dt><dd><p>Remote user from auth.</p>
</dd>
<dt>%{X}x</dt><dd><p>Extended variables.  Supported variables are:</p>
<dl>
<dt>Varnish:time_firstbyte</dt><dd><p>Time from when the request processing starts until the first
byte is sent to the client, in seconds.  For backend mode: Time
from the request was sent to the backend to the entire header
had been received.</p>
</dd>
<dt>Varnish:hitmiss</dt><dd><p>One of the ‘hit’ or ‘miss’ strings, depending on whether the request
was a cache hit or miss. Pipe, pass and synth are considered misses.</p>
</dd>
<dt>Varnish:handling</dt><dd><p>One of the ‘hit’, ‘miss’, ‘pass’, ‘pipe’ or ‘synth’ strings indicating
how the request was handled.</p>
</dd>
<dt>Varnish:side</dt><dd><p>Backend or client side. One of two values, ‘b’ or ‘c’, depending
on where the request was made. In pure backend or client mode,
this field will be constant.</p>
</dd>
<dt>Varnish:vxid</dt><dd><p>The VXID of the varnish transaction.</p>
</dd>
<dt>VCL_Log:key</dt><dd><p>The value set by std.log(“key:value”) in VCL.</p>
</dd>
<dt>VSL:tag:record-prefix[field]</dt><dd><p>The value of the VSL entry for the given tag-record prefix-field
combination. Tag is mandatory, the other components are optional.</p>
<p>The record prefix will limit the matches to those records that
have this prefix as the first part of the record content followed
by a colon.</p>
<p>The field will, if present, treat the log record as a white
space separated list of fields, and only the nth part of the
record will be matched against. Fields start counting at 1 and
run up to 255.</p>
<p>Defaults to ‘-’ when the tag is not seen, the record prefix
does not match or the field is out of bounds. If a tag appears
multiple times in a single transaction, the first occurrence
is used.</p>
</dd>
</dl>
</dd>
</dl>
</section>
<section id="signals">
<h3>SIGNALS<a class="headerlink" href="#signals" title="Permalink to this headline">¶</a></h3>
<dl class="simple">
<dt>SIGHUP</dt><dd><p>Rotate the log file (see -w option).</p>
</dd>
<dt>SIGUSR1</dt><dd><p>Flush any outstanding transactions.</p>
</dd>
</dl>
</section>
<section id="notes">
<h3>NOTES<a class="headerlink" href="#notes" title="Permalink to this headline">¶</a></h3>
<p>The %r formatter is equivalent to “%m <a class="reference external" href="http:/">http:/</a>/%{Host}i%U%q %H”. This
differs from apache’s %r behavior, equivalent to “%m %U%q %H”.
Furthermore, when using the %r formatter, if the Host header appears
multiple times in a single transaction, the first occurrence is used.</p>
</section>
<section id="example">
<h3>EXAMPLE<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h3>
<p>Log the second field of the Begin record, corresponding to the VXID
of the parent transaction:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">varnishncsa</span> <span class="o">-</span><span class="n">F</span> <span class="s2">&quot;%{VSL:Begin[2]}x&quot;</span>
</pre></div>
</div>
<p>Log the entire Timestamp record associated with the processing length:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">varnishncsa</span> <span class="o">-</span><span class="n">F</span> <span class="s2">&quot;%{VSL:Timestamp:Process}x&quot;</span>
</pre></div>
</div>
</section>
<section id="see-also">
<h3>SEE ALSO<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h3>
<p><a class="reference internal" href="varnishd.html#varnishd-1"><span class="std std-ref">varnishd</span></a>
<a class="reference internal" href="varnishlog.html#varnishlog-1"><span class="std std-ref">varnishlog</span></a>
<a class="reference internal" href="varnishstat.html#varnishstat-1"><span class="std std-ref">varnishstat</span></a>
<a class="reference internal" href="vsl.html#vsl-7"><span class="std std-ref">VSL</span></a></p>
</section>
<section id="history">
<h3>HISTORY<a class="headerlink" href="#history" title="Permalink to this headline">¶</a></h3>
<p>The varnishncsa utility was developed by Poul-Henning Kamp in
cooperation with Verdens Gang AS and Varnish Software AS. This manual page was
initially written by Dag-Erling Smørgrav &lt;<a class="reference external" href="mailto:des&#37;&#52;&#48;des&#46;no">des<span>&#64;</span>des<span>&#46;</span>no</a>&gt;, and later updated
by Martin Blix Grydeland and Pål Hermunn Johansen.</p>
</section>
<section id="copyright">
<h3>COPYRIGHT<a class="headerlink" href="#copyright" title="Permalink to this headline">¶</a></h3>
<p>This document is licensed under the same licence as Varnish
itself. See LICENCE for details.</p>
<ul class="simple">
<li><p>Copyright (c) 2006 Verdens Gang AS</p></li>
<li><p>Copyright (c) 2006-2016 Varnish Software AS</p></li>
</ul>
</section>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">varnishncsa</a><ul>
<li><a class="reference internal" href="#display-varnish-logs-in-apache-ncsa-combined-log-format">Display Varnish logs in Apache / NCSA combined log format</a><ul>
<li><a class="reference internal" href="#synopsis">SYNOPSIS</a></li>
<li><a class="reference internal" href="#description">DESCRIPTION</a></li>
<li><a class="reference internal" href="#modes">MODES</a></li>
<li><a class="reference internal" href="#format">FORMAT</a></li>
<li><a class="reference internal" href="#signals">SIGNALS</a></li>
<li><a class="reference internal" href="#notes">NOTES</a></li>
<li><a class="reference internal" href="#example">EXAMPLE</a></li>
<li><a class="reference internal" href="#see-also">SEE ALSO</a></li>
<li><a class="reference internal" href="#history">HISTORY</a></li>
<li><a class="reference internal" href="#copyright">COPYRIGHT</a></li>
</ul>
</li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="varnishlog.html"
                        title="previous chapter">varnishlog</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="varnishstat.html"
                        title="next chapter">varnishstat</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/reference/varnishncsa.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="varnishstat.html" title="varnishstat"
             >next</a> |</li>
        <li class="right" >
          <a href="varnishlog.html" title="varnishlog"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Reference Manual</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">varnishncsa</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>